/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include <stddef.h>
#include <uchar.h>

#ifndef LIBUNIC_INCLUDE_H
#define LIBUNIC_INCLUDE_H

extern unsigned int toupper_unicode(unsigned int unicode);
extern unsigned int tolower_unicode(unsigned int unicode);

extern int charsize  (const char*     char_begin);
extern int char16size(const char16_t* char_begin);
extern int char32size(const char32_t* char_begin);

extern const char*     fromchar_unicode  (unsigned int* unicode, const char*     char_begin);
extern const char16_t* fromchar16_unicode(unsigned int* unicode, const char16_t* char_begin);
extern const char32_t* fromchar32_unicode(unsigned int* unicode, const char32_t* char_begin);

extern char*     tochar_unicode  (char     dest[4], unsigned int unicode);
extern char16_t* tochar16_unicode(char16_t dest[2], unsigned int unicode);
extern char32_t* tochar32_unicode(char32_t dest[1], unsigned int unicode);

#endif /* LIBUNIC_INCLUDE_H */
